package gov.nih.nci.coppa.services.structuralroles.researchorganization.client;

import gov.nih.nci.coppa.po.Id;
import gov.nih.nci.coppa.po.ResearchOrganization;
import gov.nih.nci.coppa.services.structuralroles.researchorganization.common.ResearchOrganizationI;

import java.rmi.RemoteException;

import org.apache.axis.client.Stub;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.globus.gsi.GlobusCredential;
import org.iso._21090.CD;

/**
 * This class is autogenerated, DO NOT EDIT GENERATED GRID SERVICE ACCESS METHODS.
 *
 * This client is generated automatically by Introduce to provide a clean unwrapped API to the
 * service.
 *
 * On construction the class instance will contact the remote service and retrieve it's security
 * metadata description which it will use to configure the Stub specifically for each method call.
 *
 * @created by Introduce Toolkit version 1.2
 */
public class ResearchOrganizationClient extends ResearchOrganizationClientBase implements ResearchOrganizationI {

    /**
     * The identifier name for for Research org.
     */
    public static final String RESEARCH_ORG_IDENTIFIER_NAME = "Research org research";

    /**
     * The ii root value for Research org.
     */
    public static final String RESEARCH_ORG_ROOT = "2.16.840.1.113883.3.26.4.4.6";

    public ResearchOrganizationClient(String url) throws MalformedURIException, RemoteException {
        this(url,null);
    }

    public ResearchOrganizationClient(String url, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(url,proxy);
    }

    public ResearchOrganizationClient(EndpointReferenceType epr) throws MalformedURIException, RemoteException {
           this(epr,null);
    }

    public ResearchOrganizationClient(EndpointReferenceType epr, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(epr,proxy);
    }

    public static void usage(){
        System.out.println(ResearchOrganizationClient.class.getName() + " -url <service url>");
    }

    public static void main(String [] args){
        System.out.println("Running the Grid Service Client");
        try{
        if(!(args.length < 2)){
            if(args[0].equals("-url")){
              ResearchOrganizationClient client = new ResearchOrganizationClient(args[1]);
              // place client calls here if you want to use this main as a
              // test....
              getResearchOrg(client);
              searchResearchOrg(client);
            } else {
                usage();
                System.exit(1);
            }
        } else {
            usage();
            System.exit(1);
        }
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    private static void getResearchOrg(ResearchOrganizationClient client) throws RemoteException {
        Id id = new Id();
        id.setRoot(RESEARCH_ORG_ROOT);
        id.setIdentifierName(RESEARCH_ORG_IDENTIFIER_NAME);
        id.setExtension("592");
        ResearchOrganization result = client.getById(id);
        System.out.println(ToStringBuilder.reflectionToString(result, ToStringStyle.MULTI_LINE_STYLE));
      }
      private static void searchResearchOrg(ResearchOrganizationClient client) throws RemoteException {
              ResearchOrganization criteria = new ResearchOrganization();
            CD statusCode = new CD();
            statusCode.setCode("pending");
            criteria.setStatus(statusCode);
            ResearchOrganization[] results = client.search(criteria);
            System.out.println("Search ResearchOrg Results Found: " + results.length);
            for (ResearchOrganization idOrg : results) {
                System.out.println(ToStringBuilder.reflectionToString(idOrg, ToStringStyle.MULTI_LINE_STYLE));
            }
      }

  public gov.nih.nci.coppa.po.Id create(gov.nih.nci.coppa.po.ResearchOrganization researchOrganization) throws RemoteException, gov.nih.nci.coppa.po.faults.EntityValidationFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"create");
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.CreateRequest params = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.CreateRequest();
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.CreateRequestResearchOrganization researchOrganizationContainer = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.CreateRequestResearchOrganization();
    researchOrganizationContainer.setResearchOrganization(researchOrganization);
    params.setResearchOrganization(researchOrganizationContainer);
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.CreateResponse boxedResult = portType.create(params);
    return boxedResult.getId();
    }
  }

  public gov.nih.nci.coppa.po.ResearchOrganization getById(gov.nih.nci.coppa.po.Id id) throws RemoteException, gov.nih.nci.coppa.po.faults.NullifiedRoleFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getById");
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdRequest params = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdRequest();
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdRequestId idContainer = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdResponse boxedResult = portType.getById(params);
    return boxedResult.getResearchOrganization();
    }
  }

  public gov.nih.nci.coppa.po.ResearchOrganization[] getByIds(gov.nih.nci.coppa.po.Id[] id) throws RemoteException, gov.nih.nci.coppa.po.faults.NullifiedRoleFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByIds");
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdsRequest params = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdsRequest();
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdsRequestId idContainer = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdsRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.GetByIdsResponse boxedResult = portType.getByIds(params);
    return boxedResult.getResearchOrganization();
    }
  }

  public gov.nih.nci.coppa.po.ResearchOrganization[] search(gov.nih.nci.coppa.po.ResearchOrganization researchOrganization) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"search");
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.SearchRequest params = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.SearchRequest();
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.SearchRequestResearchOrganization researchOrganizationContainer = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.SearchRequestResearchOrganization();
    researchOrganizationContainer.setResearchOrganization(researchOrganization);
    params.setResearchOrganization(researchOrganizationContainer);
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.SearchResponse boxedResult = portType.search(params);
    return boxedResult.getResearchOrganization();
    }
  }

  public gov.nih.nci.coppa.po.StringMap validate(gov.nih.nci.coppa.po.ResearchOrganization researchOrganization) throws RemoteException {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"validate");
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.ValidateRequest params = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.ValidateRequest();
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.ValidateRequestResearchOrganization researchOrganizationContainer = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.ValidateRequestResearchOrganization();
    researchOrganizationContainer.setResearchOrganization(researchOrganization);
    params.setResearchOrganization(researchOrganizationContainer);
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.ValidateResponse boxedResult = portType.validate(params);
    return boxedResult.getStringMap();
    }
  }

  public void update(gov.nih.nci.coppa.po.ResearchOrganization researchOrganization) throws RemoteException, gov.nih.nci.coppa.po.faults.EntityValidationFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"update");
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateRequest params = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateRequest();
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateRequestResearchOrganization researchOrganizationContainer = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateRequestResearchOrganization();
    researchOrganizationContainer.setResearchOrganization(researchOrganization);
    params.setResearchOrganization(researchOrganizationContainer);
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateResponse boxedResult = portType.update(params);
    }
  }

  public void updateStatus(gov.nih.nci.coppa.po.Id targetId,gov.nih.nci.coppa.po.Cd statusCode) throws RemoteException, gov.nih.nci.coppa.po.faults.EntityValidationFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"updateStatus");
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateStatusRequest params = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateStatusRequest();
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateStatusRequestTargetId targetIdContainer = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateStatusRequestTargetId();
    targetIdContainer.setId(targetId);
    params.setTargetId(targetIdContainer);
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateStatusRequestStatusCode statusCodeContainer = new gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateStatusRequestStatusCode();
    statusCodeContainer.setCd(statusCode);
    params.setStatusCode(statusCodeContainer);
    gov.nih.nci.coppa.services.structuralroles.researchorganization.stubs.UpdateStatusResponse boxedResult = portType.updateStatus(params);
    }
  }

}
